# roota

[![npm version](https://badge.fury.io/js/roota.svg)](https://badge.fury.io/js/roota)
[![Build Status](https://travis-ci.org/gitfish/roota.svg?branch=master)](https://travis-ci.org/gitfish/roota)

roota is a simple promise-based routing framework, influenced heavily by express.

```javascript
const r = new Router();

r.use("/big/pot/:potNumber", req => {
    return `Big Pot ${req.params.potNumber}`;
});

r.use("/small/cup/:cupNumber", req => {
    return `Small Cup ${req.params.cupNumber}`;
});

r.handleRequest({ path: "/big/pot/1" }).then(value => {
    console.log(`-- Value ${value}`);
}).then(() => {
    return r.handleRequest({ path: "/small/cup/9" }).then(value => {
        console.log(`-- Value: ${value}`);
    });
});
```
